<template>
    <!-- HEADER -->
    <div class="dsd-header">
      <dataset-details-header-title />
      <div class="d-flex offset-lg-1 col-lg-10 mt-1 px-0 flex-nowrap justify-content-between dsd-header-info">
        <dataset-details-header-catalogue class="mr-2"/>
        <property-value
          v-if="!hidePublisher && showObject(getPublisher)"
          :property="$t('message.metadata.publisher')"
          :tooltip="$t('message.tooltip.datasetDetails.publisher')"
          :value="getPublisherName"
          class="mr-2"
        />
        <property-value
          v-if="!hideDate"
          :property="$t('message.metadata.updated')"
          :tooltip="$t('message.tooltip.datasetDetails.updated')"
          :value="getModificationDate"
          :isDate="true"
        />
        <dataset-details-likes class="d-lg-none" v-if="useCommentsAndLikes" :datasetId="getID"/>

      </div>
    </div>
  </template>

  <script>
    // import Actions and Getters from Store Module
    import { mapGetters } from 'vuex';
    // import helper functions
    import { has, isNil, isObject } from 'lodash-es';
    import {
        DatasetDate,
        DatasetDetailsHeaderCatalogue,
        AppLink,
        dateFilters,
        PropertyValue,
        getTranslationFor, getCountryFlagImg, truncate,
    } from "@piveau/piveau-hub-ui-modules"
    import DatasetDetailsLikes from './datasetDetailsCommentsAndLikes/DatasetDetailsLikes.vue';
    import DatasetDetailsHeaderTitle from "./DatasetDetailsHeaderTitle.vue"

    export default {
      name: 'datasetDetailsHeader',
      components: {
        PropertyValue,
        DatasetDetailsHeaderCatalogue,
        DatasetDetailsLikes,
        DatasetDetailsHeaderTitle,
        DatasetDate,
        AppLink,
      },
      props: {
        previousRoute: {
          type: Object,
          default: () => {}
        }
      },
      dependencies: 'DatasetService',
      data() {
        return {
          hidePublisher: this.$env.content.datasetDetails.header.hidePublisher,
          hideDate: this.$env.content.datasetDetails.header.hideDate,
          useCommentsAndLikes: this.$env.content.datasetDetails.showRatingService,
        };
      },
      computed: {
        // import store-getters
        ...mapGetters('datasetDetails', [
          'getCatalog',
          'getCountry',
          'getLanguages',
          'getPublisher',
          'getModificationDate',
          'getID',
        ]),
        getPublisherName() {
          if (has(this.getPublisher, 'name') && !isNil(this.getPublisher.name)) {
            return this.getPublisher.name;
          } else {
            return "";
          }
        }
      },
      methods: {
        has,
        isNil,
        isObject,
        truncate,
        getTranslationFor,
        getCountryFlagImg,
        filterDateFormatUS(date) {
          return dateFilters.formatUS(date);
        },
        filterDateFormatEU(date) {
          return dateFilters.formatEU(date);
        },
        showObject(object) {
          return !isNil(object) && isObject(object) && !Object.values(object).reduce((keyUndefined, currentValue) => keyUndefined && currentValue === undefined, true);
        },
        filterDateFromNow(date) {
          return dateFilters.fromNow(date);
        }
      },
    };
  </script>

  <style lang="scss">
    // .dsd-header-property > span:first-child  {
    //   // @extend .by-caption;
    //   width: fit-content;
    //   text-transform: uppercase;
    //   font-weight: 700;
    //   display: block;
    //   font-family: "Inter Variable", Arial, Helvetica, "Sans-Serif";
    //   font-size: 12px;
    //   line-height: 150%;
    //   margin-bottom: 4px;
    // }
    //
    // @media screen and (max-width: 575px) {
    //   .dsd-header-properties {
    //     flex-direction: column;
    //   }
    //   .dsd-header-property:first-child {
    //     margin-bottom: 16px;
    //   }
    // }

  </style>
